--
-- Created by IntelliJ IDEA.
-- User: Jens
-- Date: 25.03.14
-- Time: 18:38
-- To change this template use File | Settings | File Templates.
--

local L = LibStub("AceLocale-3.0"):GetLocale("PimpMyProfession")
local tradeskill_professions = {
    ['01Tailoring'] = {spellid=3908, recipes=true},
    ['02Enchanting'] = {spellid=7411, recipes=true},
    ['04Smelting'] = {spellid=2656, recipes=true},
    ['05Blacksmithing'] = {spellid=3100, recipes=true},
    ['06Alchemy'] = {spellid=2259, recipes=true},
    ['07Leatherworking'] = {spellid=2108, recipes=true},
    ['08Engineering'] = {spellid=4036, recipes=true},
    ['09Jewelcrafting'] = {spellid=25229, recipes=true},
    ['10Inscription'] = {spellid=45357, recipes=true},
    ['11Runeforging'] = {spellid=53428, recipes=true},
    ['14Cooking'] = {spellid=2550, recipes=true},
    ['16First Aid'] = {spellid=3273, recipes=true},
};

local tradeskill_type_color = {
	["optimal"] = {r=1.00, g=0.50, b=0.25},
	["medium"] = {r=1.00, g=1.00, b=0.00},
	["easy"] = {r=0.25, g=0.75, b=0.25},
	["trivial"] = {r=0.50, g=0.82, b=0}
}
PimpMyProfession.TradeWindowIsShown = false

local Guide = nil


function PimpMyProfession:CreateNeedListFrame(beruf, myrank)
    --for index, key in pairs(PimpMyProfession.professions) do
	--print(index,key.skillline)
    --end
    PimpMyProfession:GetNeedList(beruf, myrank)
    local f = CreateFrame("Frame",nil, UIParent)
    f:SetClampedToScreen(true)
    f:SetMovable(true)
    f:EnableMouse(true)
    f:SetScript("OnMouseDown", function(self,button)
        if button == "LeftButton" and not self.isMoving then
            self:StartMoving();
            self.isMoving = true;
        end
    end)
    f:SetScript("OnMouseUp", function(self, button)
        if button == "LeftButton" and self.isMoving then
            self:StopMovingOrSizing()
            self.isMoving = false
        end
    end)
    f:SetScript("OnHide", function(self)
        if(self.isMoving) then
            self:StopMovingOrSizing()
            self.isMoving=false
        end
    end)
    f:SetWidth(460)
    f:SetHeight(300)
    f:SetBackdrop{
        bgFile = [[Interface\ToolTips\ChatBubble-Background.blp]],
        edgeFile = [[Interface\ToolTips\UI-Tooltip-Border]],
        edgeSize = 16,
        tile = true, tileSize = 16,
        insets = {left = 4, right = 4, top = 4, bottom = 4}
    }
    f:SetPoint("CENTER",0,0)
    f.title = f:CreateFontString("NeedList_Title", "OVERLAY", "GameFontNormal")
    f.title:SetPoint("TOP",0,-8)
    f.title:SetText(L["NeedList Frame Title"])
    f.close = CreateFrame("Button", "nList_close", f, "UIPanelCloseButton")
    f.close:SetPoint("TOPRIGHT", 0,-2)

    --laden der Needliste
    f.items = {}
    local idx=1
    for index, key in pairs(PimpMyProfession.actualGuide.needlist) do
        local item = CreateFrame("Button", "Nlist_item" ..idx, f, "SecureActionButtonTemplate")
        item:SetSize(48,48)
        item:SetScript("OnEnter", function(self,...)
            print(self.data.iName, self.data.iType, self.data.iRarity)

        end)
		local border = item:CreateTexture(nil, 'OVERLAY')
        border:SetWidth(67)
        border:SetHeight(67)
        border:SetPoint('CENTER', item)
        --border:SetTexture([[Interface\Buttons\UI-ActionButton-Border]])
        r,g,b,h = GetItemQualityColor(key.iRarity)
        border:SetVertexColor(r,g,b)
        border:SetBlendMode('ADD')

        item.icon = item:CreateTexture("", "BACKGROUND")
        item.icon:SetAllPoints(item)
        item.icon:SetSize(64,64)
        item.icon:SetTexture(key.texture)
        item.icon:Show()
        item.data = key
        local needCount = GetItemCount(key.itemid)
        item.count = item:CreateFontString("$parentCount", "BORDER", "NumberFontNormal")
        item.count:SetPoint("BOTTOMRIGHT", -5,2)
        item.count:SetJustifyH("RIGHT")

        -- ist die benötigte Anzahl vorhanden, dann Schriftfarbe auf grün stellen
        if(needCount >= key.count) then
			item.count:SetTextColor(0, 1.0,0,1)
        else
			item.count:SetTextColor(1,1,1,1)
        end
        item.count:SetText(needCount.."/"..key.count)

        f.items[idx] = item

        if idx == 1 then
            item:SetPoint("TOPLEFT", 10, 0)
        elseif idx == 8 or idx == 15 or idx == 22 then
            item:SetPoint("TOPLEFT", f.items[idx - 7], "BOTTOMLEFT", 0, -7)
        else
            item:SetPoint("TOPLEFT", f.items[idx - 1], "TOPRIGHT", 12, 0)
        end

        idx = idx +1

    end

    return f
end

function PimpMyProfession:GetNeedList2(profession)

    if PimpMyProfession.MainFrame:IsVisible() then PimpMyProfession.MainFrame:Hide() end
    --Handwerksfenster öffnen
	for name, data in pairs(tradeskill_professions) do     
        local spellid = data.spellid;
        local spellname, rank, texture, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spellid);
		if(spellname == profession.name and PimpMyProfession.TradeWindowIsShown == false) then
			CastSpellByName(spellname,"player")
		end
	end

	PimpMyProfession:UpdateGuide(profession)

    local f = CreateFrame("Frame", "needlist", UIParent)
	f:RegisterEvent("TRADE_SKILL_SHOW")
	f:RegisterEvent("TRADE_SKILL_CLOSE")
    f:ClearAllPoints()
    f:SetClampedToScreen(true)
    f:EnableMouse(true)
    f:SetMovable(true)
    f:SetPoint("CENTER", UIParent)
    f:SetWidth(360)
    f:SetHeight(400)
	f:SetBackdrop{
        bgFile = [[Interface\ToolTips\UI-Tooltip-Background]],
        edgeFile = [[Interface\AddOns\PimpMyProfession\Textures\FrameTitle-border]],
        edgeSize = 32,
        tile = true, tileSize = 16,
        insets = {left = 1, right = 1, top = 20, bottom = 1}
    }
	f:SetScript("OnMouseDown", function(self,button) 
		if button == "LeftButton" then
			self:StartMoving()
			self.isMoving = true
		end
	end)
	f:SetScript("OnMouseUp", function(self) 
		if self.isMoving then
			self:StopMovingOrSizing()
			self.isMoving = false
		end

	end)
	f:SetBackdropBorderColor(1.0,0.0,0.0)
	f:SetBackdropColor(25/255,25/255,24/255)

	f.Title = f:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	f.Title:SetPoint("TOP",f,"TOP", 0,-12)
	f.Title:SetJustifyH("CENTER")
	f.Title:SetText(profession.name.."["..profession.plevel.."]")

	--Rezeptübersicht
	
	f.Rezepte=PimpMyProfession:CreateInsetFrame(L["Title Receipt in Guidelist"], f, 5,-55)
	if(profession.rank < 525) then
		PimpMyProfession:GetActualReceiptInsetFrame(PimpMyProfession:GetActualReceipt(profession), f.Rezepte)
	else
		
		PimpMyProfession:GetActualReceiptInsetFrame(PimpMyProfession:GetOptionalsReceipts(profession),f.Rezepte)
	end
	
	--Farm und Einkaufsliste
	local height = f.Rezepte:GetHeight()+65 
	f.Farmlist = PimpMyProfession:CreateInsetFrame(L["NeedList Frame Title"],f,5, -(f.Rezepte:GetHeight()+65))
	if( PimpMyProfession.AktualFarmlist ~= nil) then
		--print(PimpMyProfession.ActualFarmlist)
	   	f.Farmlist.items = {}
		local idx = 1
		for i=1, # PimpMyProfession.AktualFarmlist do
			
			local item = CreateFrame("Button", "reagenz"..idx,f.Farmlist, "SecureActionButtonTemplate")
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo( PimpMyProfession.AktualFarmlist[i][2])
			item:SetSize(48,48)
			item.icon = item:CreateTexture("", "BACKGROUND")
			item.icon:SetAllPoints(item)
			item.icon:SetSize(64,64)
			item.icon:SetTexture(texture)
			item.icon:Show()
			item.data =  PimpMyProfession.AktualFarmlist[i]
			local needCount = GetItemCount( PimpMyProfession.AktualFarmlist[i][2])
			item.count = item:CreateFontString("$parentCount", "BORDER", "NumberFontNormal")
			item.count:SetPoint("BOTTOMRIGHT", -5,2)
			item.count:SetJustifyH("RIGHT")

			-- ist die benötigte Anzahl vorhanden, dann Schriftfarbe auf grün stellen
			if(needCount >=  PimpMyProfession.AktualFarmlist[i][1]) then
				item.count:SetTextColor(0, 1.0,0,1)
			else
				item.count:SetTextColor(1,1,1,1)
			end
			item.count:SetText(needCount.."/".. PimpMyProfession.AktualFarmlist[i][1])

			f.Farmlist.items[idx] = item
			if idx == 1 then
				item:SetPoint("TOPLEFT", 10, -20)
			elseif idx == 6 then
				item:SetPoint("TOPLEFT", f.Farmlist.items[idx - 5], "BOTTOMLEFT", 0, -5)
			else
				item:SetPoint("TOPLEFT", f.Farmlist.items[idx - 1], "TOPRIGHT", 12, 0)
			end

			idx = idx +1

		end
	end
	f.Farmlist:SetHeight(130)

	f:SetHeight(height + 135)
	f.CloseButton = CreateFrame("Button","nlisFrame_CloseButton", f)
	f.CloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
	f.CloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
	f.CloseButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
	f.CloseButton:SetWidth(20)
	f.CloseButton:SetHeight(20)
	f.CloseButton:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-12)
	f.CloseButton:SetScript("OnClick", function(self) self:GetParent():Hide() end)
	
	--LoadAddOn("Blizzard_TradeSkillUI")

end

function PimpMyProfession:GetActualReceiptInsetFrame(rezept, frame)
	local f = CreateFrame("Frame", nil, frame)
	f:SetAllPoints(frame)

	--print(rezept[1])
	local rfont = CreateFont("RezeptNameFontNormal")
	rfont:CopyFontObject(GameFontNormal)
	rfont.font = rfont:GetFont()
	rfont:SetFont(rfont.font,14)


	f.icon = f:CreateTexture(nil,"ARTWORK")
	f.icon:SetHeight(48)
	f.icon:SetWidth(48)
	f.icon:SetPoint("LEFT",10,0)
	f.icon:SetTexture(rezept.icon)

	local nf = CreateFrame("Frame",nil,f)
	nf:SetWidth(frame:GetWidth() -f.icon:GetWidth() - 64)
	nf:SetHeight(f.icon:GetHeight())
	nf:SetPoint("LEFT", f.icon, "RIGHT",4,0)

	local rname = nf:CreateFontString(nil, "BACKGROUND", "RezeptNameFontNormal")
	rname:SetPoint("TOPLEFT", nf,0,4)
	rname:SetWidth(nf:GetWidth() - 4)
	rname:SetJustifyH("LEFT")
	rname:SetText(rezept.anzahl.." x "..rezept.name)
	rname:SetTextColor(tradeskill_type_color[rezept.textColor].r,tradeskill_type_color[rezept.textColor].g,tradeskill_type_color[rezept.textColor].b)

	if rezept.inTradeList then
		local rbar = CreateFrame("StatusBar",nil, nf)
		rbar:SetBackdrop{
            bgFile = "Interface\\TARGETINGFRAME\\UI-StatusBar"
        }
		rbar:SetPoint("BOTTOMLEFT",nf,0,4)
		rbar:SetWidth(nf:GetWidth() - 4)
		rbar:SetHeight(20)
		rbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
		rbar:GetStatusBarTexture():SetHorizTile(false)
        rbar:GetStatusBarTexture():SetVertTile(false)
        rbar:SetMinMaxValues(0, rezept.anzahl)
        rbar:SetValue(0)
        rbar:SetStatusBarColor(70/255,94/255,202/255,0.66)

		local aText = rbar:CreateFontString(nil, "OVERLAY","GameFontHighlightSmall")
		aText:SetPoint("CENTER", rbar,"CENTER",2)
        aText:SetJustifyH("LEFT")
        aText:SetText("0 / "..rezept.anzahl)
	else
		local learn = nf:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
		learn:SetPoint("BOTTOMLEFT", nf, 0,4)
		learn:SetWidth(nf:GetWidth() - 4)
		learn:SetJustifyH("LEFT")
		learn:SetText(L["Yoe must learn this receipt"])
	end
end

function PimpMyProfession:CreateInsetFrame(title, frame, offX, offY)
	local f = CreateFrame("Frame", nil, frame)
	f:SetHeight(100)
	f:SetWidth(350)
	f:SetBackdrop{
		bgFile = [[Interface\ToolTips\ChatBubble-Background]], tile=true, tileSize=16,
		edgeFile=[[Interface\ToolTips\UI-Tooltip-Border]],
		edgeSize=16,
		insets={left = 4, right = 4, top = 4, bottom = 4}
	}
	f.header = CreateFrame("Frame",nil,f)
	f.header:SetWidth(200)
	f.header:SetHeight(32)
	f.header:SetPoint("TOPLEFT",f,20,15)
	f.header.border = f.header:CreateTexture(nil,"ARTWORK")
	f.header.border:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-Skills-BarBorder]])
	f.header.border:SetAllPoints(f.header)
	f.header.backdrop = f.header:CreateTexture(nil,"BACKGROUND")
	f.header.backdrop:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Title-Background]])

	f.header.backdrop:SetPoint("BOTTOMLEFT",f.header,4,8)
	f.header.backdrop:SetPoint("BOTTOMRIGHT",f.header,-2,8)
	f.header.backdrop:SetHeight(16)
	f.header.title = f.header:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
	f.header.title:SetPoint("TOP",f.header,"TOP",0,-11)
	f.header.title:SetText(title)
	f:SetPoint("TOPLEFT",offX,offY)
	return f

end

function PimpMyProfession:GetActualReceipt(profession)
   -- ermitteln des aktuellen Rezeptes meines Skillbereiches
   if PimpMyProfession.ActualReceipts == nil then print("Keine aktuellen Rezepte vorhanden.") return nil end

	local Rezept = {
		inTradeList = false,
		reagenz={}
	}
	for i= 1, #PimpMyProfession.ActualReceipts do
		if PimpMyProfession.ActualReceipts[i][1] <= profession.rank and PimpMyProfession.ActualReceipts[i][2] >= profession.rank  then
		   -- das ist das aktuelle Rezept das wir herstellen wollen
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(PimpMyProfession.ActualReceipts[i][4])
			
			Rezept.icon = GetItemIcon(PimpMyProfession.ActualReceipts[i][4])
			Rezept.name = name
			Rezept.anzahl = PimpMyProfession.ActualReceipts[i][3]

			local sname, srank, sicon, spowerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(PimpMyProfession.ActualReceipts[i][5])
			for n=1,GetNumTradeSkills() do
				local skillName, skillType, numAvailable, isExpanded, serviceType, numSkillUps, indentLevel, showProgressBar, currentRank, maxRank, startingRank = GetTradeSkillInfo(n)
				Rezept.spellID = PimpMyProfession.ActualReceipts[i][5] 
				Rezept.textColor = skillType

 				if skillName == sname then
				   Rezept.inTradeList = true				
				for ri=1, GetTradeSkillNumReagents(key) do
				   	local rname,rtext,rcount,prcount = 	 GetTradeSkillReagentInfo(key, ri)
					local reagent ={
						rName = rname,
						rText = rtext,
						rCount = rcount,
						prCount = prcount
					}
					table.insert(Rezept.reagenz,reagent)
				end
				end
			end

		end 
	end
	return Rezept
end

function PimpMyProfession:UpdateGuide(profession)
    if PimpMyProfession.actualGuide == nil then return nil end
    Guide = PimpMyProfession:GetModule("Guide")
    local von, bis, plevel
    for index, key in pairs(Guide.SkillAreas) do
        if profession.maxrank == key.t then
            von = key.f
            bis = key.t
            plevel = key.name
			profession.plevel=key.name
        end
    end
    --ermitteln aller rezepte meines Professionlevels
    local levelRezepte = {}
    for i=1, #PimpMyProfession.actualGuide do
        if PimpMyProfession.actualGuide[i][1] >= profession.rank and PimpMyProfession.actualGuide[i][2] <= bis then
            table.insert(levelRezepte,PimpMyProfession.actualGuide[i])
        end
    end


    local farmlist = {}
	PimpMyProfession.ActualReceipts = {}
	 PimpMyProfession.AktualFarmlist = {}
    for i= 1, #levelRezepte do
        local dummy = {}
        if levelRezepte[i][1] >= profession.rank and levelRezepte[i][2] <= profession.maxrank then
            local rcount = levelRezepte[i][3]  --Anzahl der herzustellenden Items
            local dist = levelRezepte[i][2] - profession.rank
            -- soltte mein skill zwischen einem Rezept liegen, dann berechne die noch erforderliche Menge
            if levelRezepte[i][1] >= profession.rank and levelRezepte[i][2]<=profession.rank then
                --Da mann mehr herstellen kann als es skill punkte gibt, muss entsprechend berechnet werden
                if(levelRezepte[i][2] - levelRezepte[i][1]) < levelRezepte[i][3] then
                    dist = dist + (levelRezepte[i][3] - (levelRezepte[i][2] - levelRezepte[i][1]))
                end
                for a=1, #levelRezepte[i][6] do
                    levelRezepte[i][6][a][1] = levelRezepte[i][6][a][3] * dist
                end
            end
            for a = 1, #levelRezepte[i][6] do
                table.insert(dummy,levelRezepte[i][6][a])
            end
			table.insert(PimpMyProfession.ActualReceipts,levelRezepte[i])
        end

        --zuzammenstellen der farmliste
        for x= 1, #dummy do
            local isda = false
            for y=1, #farmlist do
                if farmlist[y][2] == dummy[x][2] then
                    farmlist[y][1] = farmlist[y][1] + dummy[x][1]
                    isda = true
                end
            end
            if not isda then table.insert(farmlist,dummy[x]) end
        end
    end
    PimpMyProfession.AktualFarmlist = farmlist
	
end

function PimpMyProfession:GetOptionalsReceipts(profession)
	local result = nil
	local farmlist = {}
	--Sollte im Guide nur bis skillLine 525 daten verfügbar sein prüfen ob es ne GuideDB_Alchemy.from525 gibt
	if(profession.rank >= 525 and Guide ~= nil) then
		if PimpMyProfession.optionalGuide ~= nil then
		   --vorladen der optinalen Rezepte
			local optionals = {}
			for i=1, #PimpMyProfession.optionalGuide do
				for a=1, #PimpMyProfession.optionalGuide[i][4] do 
					--print(PimpMyProfession.optionalGuide[i][4][a][3][1])
					for r=1, #PimpMyProfession.optionalGuide[i][4][a][3] do
						local isda = false
						for z= 1, #farmlist do 
							if farmlist[z][2] == PimpMyProfession.optionalGuide[i][4][a][3][r][2] then
								farmlist[z][1] = farmlist[z][1] + PimpMyProfession.optionalGuide[i][4][a][3][r][1]
								
								isda = true
							end
						end
						if not isda then table.insert(farmlist, PimpMyProfession.optionalGuide[i][4][a][3][r]) end
					end
				end
			end
			
			PimpMyProfession.AktualFarmlist = farmlist			
			
			for i=1, #PimpMyProfession.optionalGuide do
				if profession.rank >= PimpMyProfession.optionalGuide[i][1] and profession.rank <= PimpMyProfession.optionalGuide[i][2] then
					--prüfen ob der Player eines der Rezepte erforscht hat
					local orezepte = PimpMyProfession.optionalGuide[i][4]
					for y = 1,#orezepte do
						local sname, srank, sicon, spowerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(orezepte[y][2])
						local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(orezepte[y][1])

						for n=1, GetNumTradeSkills() do
							skillName, skillType, numAvailable, isExpanded, serviceType, numSkillUps, indentLevel, showProgressBar, currentRank, maxRank, startingRank = GetTradeSkillInfo(n)
							if(skillName ==  sname) then
								result = {}
								result.name = skillName
								result.inTradeList = true
								result.textColor = skillType
								result.icon =texture
								result.anzahl = PimpMyProfession.optionalGuide[i][3]
								result.reagenz = {}
								for ri=1, GetTradeSkillNumReagents(n) do
	  				   				local rname,rtext,rcount,prcount = 	 GetTradeSkillReagentInfo(n, ri)
									local reagent ={
										rName = rname,
										rText = rtext,
										rCount = rcount,
										prCount = prcount
									}
									table.insert(result.reagenz,reagent)
								end
								return result
							end
						end
					end
				end
			end
			if(result == nil) then
				local idx=1
				for i=1, #PimpMyProfession.optionalGuide do
					if profession.rank >= PimpMyProfession.optionalGuide[i][1] and profession.rank <= PimpMyProfession.optionalGuide[i][2] then
						idx=i				
					end
				end
				local sname, srank, sicon, spowerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(PimpMyProfession.optionalGuide[idx][4][1][2])
				result = {}
				result.name = sname
				result.inTradeList = false
				result.textColor = 'optimal'
				result.icon =sicon
				result.anzahl = PimpMyProfession.optionalGuide[1][3]
			end
		end
	end
	return result
end

function PimpMyProfession:TRADE_SKILL_SHOW()
   PimpMyProfession.TradeWindowIsShown = true
end

function PimpMyProfession:TRADE_SKILL_CLOSE()
   PimpMyProfession.TradeWindowIsShown = false	
end


